"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Breakend(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3

        return {
            "mate": opencb_2_9_3.BreakendMate,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3

        return {
            "orientation": opencb_2_9_3.BreakendOrientation,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.BreakendMate": opencb_2_9_3.BreakendMate,
            "org.opencb.biodata.models.variant.avro.BreakendOrientation": opencb_2_9_3.BreakendOrientation,
            "org.opencb.biodata.models.variant.avro.Breakend": opencb_2_9_3.Breakend,
        }

    __slots__ = [
        "insSeq",
        "mate",
        "orientation",
    ]

    def __init__(
        self,
        insSeq=None,
        mate=None,
        orientation=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.Breakend model.

        :param insSeq:
        :type insSeq: None | str
        :param mate:
        :type mate: None | BreakendMate
        :param orientation:
        :type orientation: None | BreakendOrientation
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
